//+------------------------------------------------------------------+
//|                                              TestMultiThread.mq4 |
//|                               Copyright 2015, Alexey Volchanskiy |
//|                                          https://mql.gnomio.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Alexey Volchanskiy"
#property link      "https://mql.gnomio.com/"
#property version   "1.00"
#property strict
#property description ""

extern long num_steps   = 1000000;  //    
extern int  ind_steps   = 500;      //    

ulong SumTime = 0;

void OnTick()
{
    ulong dtStart, dtStop;
    static int indCount = 0;
    static ulong count = 0;
    double step;
    double x, pi, sum = 0.0;
    int i;
    while(!IsStopped())
    {
        dtStart = GetMicrosecondCount();
        step = 1./(double)num_steps;
        for (i=0; i < num_steps; i++)
        {
            x = (i + .5)*step;
            sum = sum + 4.0/(1.+ x*x);
        }
        pi = sum*step;
        count++;
        dtStop = GetMicrosecondCount();
        SumTime += dtStop - dtStart;
        if(indCount++ > ind_steps)
        {
            ulong t = SumTime / count;
            printf("   %u \n", t);
            indCount = 0;
        }
    }    
}
